#include <stdlib.h>
#include <string.h>

#ifdef USE_NLLIBC
#include <nllibc.h>
#endif

#include "command.h"

struct command {
  char *name;
  char *other_name;
  command_type_t type;
} commands[] = {
  { "########", NULL, COMMAND_COMMENT  },
  { "RUN"     , "RN", COMMAND_RUN      },
  { "EDIT"    , "ET", COMMAND_EDIT     },
  { "END"     , NULL, COMMAND_END      },
  { "EXIT"    , NULL, COMMAND_EXIT     },
  { "QUIT"    , "QT", COMMAND_EXIT     },
  { "BREAK"   , "BK", COMMAND_BREAK    },
  { "STEP"    , "SE", COMMAND_STEP     },
  { "STOP"    , "SP", COMMAND_STOP     },
  { "CONTINUE", "CN", COMMAND_CONTINUE },
  { "LET"     , "LT", COMMAND_LET      },
  { "PRINT"   , "PT", COMMAND_PRINT    },
  { "GOTO"    , "GT", COMMAND_GOTO     },
  { "GOSUB"   , "GS", COMMAND_GOSUB    },
  { "RETURN"  , "RT", COMMAND_RETURN   },
  { "FOR"     , "FR", COMMAND_FOR      },
  { "NEXT"    , "NX", COMMAND_NEXT     },
  { "NEW"     , "NW", COMMAND_NEW      },
  { "LIST"    , "LS", COMMAND_LIST     },
  { "WAIT"    , "WT", COMMAND_WAIT     },
  { NULL      , NULL, COMMAND_UNKNOWN  }
};

command_type_t search_command(const char *name)
{
  struct command *p;
  int len;

  for (p = commands; p->name; p++) {
    if (!strcmp(p->name, name))
      return p->type;
  }

  for (p = commands; p->name; p++) {
    if (p->other_name && !strcmp(p->other_name, name))
      return p->type;
  }

  len = strlen(name);
  if (len > 0) {
    for (p = commands; p->name; p++) {
      if (!strncmp(p->name, name, len))
	return p->type;
    }
  }

  return COMMAND_UNKNOWN;
}
