#ifndef __NLL_LIB_H_INCLUDED__
#define __NLL_LIB_H_INCLUDED__

enum {
  NLL_ERRCODE_UNKNOWN                     = - 1,
  NLL_ERRCODE_FILE_NOT_FOUND              = -10,
  NLL_ERRCODE_LINE_BUFFER_OVER            = -20,
  NLL_ERRCODE_LINE_TOO_LONG               = -21,
  NLL_ERRCODE_LINE_NOT_FOUND              = -22,
  NLL_ERRCODE_VARIABLE_INVALID_NAME       = -30,
  NLL_ERRCODE_VALUE_STACK_OVER            = -40,
  NLL_ERRCODE_VALUE_LESS_PARAMETER        = -41,
  NLL_ERRCODE_VALUE_DIV_ZERO              = -42,
  NLL_ERRCODE_VALUE_INVALID_OPERATOR      = -43,
  NLL_ERRCODE_VALUE_INVALID_VALUE         = -44,
  NLL_ERRCODE_VALUE_UNSUPPORTED_OPERATOR  = -45,
  NLL_ERRCODE_VALUE_NO_CONTINUE_POINT     = -46,
  NLL_ERRCODE_WORD_TOO_LONG               = -50,
  NLL_ERRCODE_LABEL_BUFFER_OVER           = -60,
  NLL_ERRCODE_LABEL_TOO_LONG              = -61,
  NLL_ERRCODE_LABEL_NOT_FOUND             = -62,
  NLL_ERRCODE_POSITION_STACK_OVER         = -70,
  NLL_ERRCODE_POSITION_LESS_PARAMETER     = -71,
  NLL_ERRCODE_POSITION_DIFFERENT_TYPE     = -72,
  NLL_ERRCODE_POSITION_DIFFERENT_VARIABLE = -73,
};

void nll_error_print(const char *filename, int line,
		     int errcode, const char *param);

void nll_error_exit(const char *filename, int line,
		    int errcode, const char *param);

#define NLL_ERRPRINT(r, param) \
	nll_error_print(__FILE__, __LINE__, r, param)

#define NLL_ERREXIT(r, param) \
	nll_error_exit(__FILE__, __LINE__, r, param)

void nll_finished_clear(void);
void nll_finish(void);
int nll_is_finished(void);

#endif
