#ifndef __NLL_POSITION_H_INCLUDED__
#define __NLL_POSITION_H_INCLUDED__

typedef enum {
  POSITION_TYPE_FOR,
  POSITION_TYPE_GOSUB,
} position_type_t;

typedef union position_param {
  struct {
    char variable[16];
    int limit;
    int step;
  } _for;
} *position_param_t;

typedef struct position {
  position_type_t type;
  line_t line;
  int column;
  union position_param param;
} *position_t;

int position_init(void);
int position_push(position_type_t type, line_t line, int column,
		  position_param_t param);
int position_pop(position_type_t type, line_t *linep, int *columnp,
		 position_param_t param);
int position_get(line_t line, int column, position_t *positionp);

#endif
