#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#ifdef USE_NLLIBC
#include <nllibc.h>
#endif

#include "lib.h"
#include "word.h"

static int _word_get(char **pp, const char *separator, char *buffer, int size)
{
  char c, *p;
  char quat = '\0';
  int escape = 0;

  while (isspace(**pp))
    (*pp)++;

  p = buffer;

  while (1) {
    c = **pp;
    if (c == '\0') {
      break;
    }
    if (quat) {
      if (escape)
	escape = 0;
      else if (c == quat)
	quat = '\0';
      else if (c == '\\')
	escape = 1;
    } else if ((c == '\'') || (c == '\"')) {
      quat = c;
      escape = 0;
    } else if (c == ';') {
      break;
    } else if (strchr(separator, c)) {
      (*pp)++;
      break;
    }
    **pp = quat ? c : toupper(c);
    if (p + 1 >= buffer + size)
      return NLL_ERRCODE_WORD_TOO_LONG;
    *(p++) = **pp;
    if (c == ':')
      break;
    (*pp)++;
  }

  *p = '\0';

  return 0;
}

int word_get_word(char **pp, char *buffer, int size)
{
  return _word_get(pp, ", \t\n\r", buffer, size);
}

int word_get_value(char **pp, char *buffer, int size)
{
  return _word_get(pp, ",", buffer, size);
}
