#if defined(__linux__)
#if defined(__aarch64__)

/*
 * Use Linux system call.
 */

#define SYS_exit          1
#define SYS_fork          2
#define SYS_wait4       114
#define SYS_kill         37
#define SYS_execve       11

#define SYS_read          3
#define SYS_write         4
#define SYS_open          5
#define SYS_close         6

#define SYS_dup          41
#define SYS_pipe         42
#define SYS_dup2         63
#define SYS_pipe2       359

#define SYS_sigaction    67 /* rt_sigaction is 174 */
#define SYS_sigprocmask 126 /* rt_sigprocmask is 175 */

#define SYS_getpid       20
#define SYS_getppid      64
#define SYS_getsid      147
#define SYS_setsid       66
#define SYS_getpgid     132
#define SYS_setpgid      57
#define SYS_getpgrp      65

#define SYS_chdir        12
#define SYS_ioctl        54
#define SYS_brk          45
#define SYS_getdents    141
#define SYS_getcwd      183

	.section .text

	.globl	___exit
	.type	___exit, %function
___exit:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_exit
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__fork
	.type	__fork, %function
__fork:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_fork
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__wait4
	.type	__wait4, %function
__wait4:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_wait4
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__kill
	.type	__kill, %function
__kill:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_kill
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__execve
	.type	__execve, %function
__execve:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_execve
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__read
	.type	__read, %function
__read:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_read
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__write
	.type	__write, %function
__write:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_write
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__open
	.type	__open, %function
__open:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_open
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__close
	.type	__close, %function
__close:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_close
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__dup
	.type	__dup, %function
__dup:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_dup
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__pipe
	.type	__pipe, %function
__pipe:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_pipe
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__dup2
	.type	__dup2, %function
__dup2:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_dup2
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__pipe2
	.type	__pipe2, %function
__pipe2:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_pipe2
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__sigaction
	.type	__sigaction, %function
__sigaction:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_sigaction
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__sigprocmask
	.type	__sigprocmask, %function
__sigprocmask:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_sigprocmask
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__getpid
	.type	__getpid, %function
__getpid:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_getpid
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__getppid
	.type	__getppid, %function
__getppid:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_getppid
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__getsid
	.type	__getsid, %function
__getsid:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_getsid
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__setsid
	.type	__setsid, %function
__setsid:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_setsid
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__getpgid
	.type	__getpgid, %function
__getpgid:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_getpgid
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__setpgid
	.type	__setpgid, %function
__setpgid:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_setpgid
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__getpgrp
	.type	__getpgrp, %function
__getpgrp:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_getpgrp
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__chdir
	.type	__chdir, %function
__chdir:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_chdir
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__ioctl
	.type	__ioctl, %function
__ioctl:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_ioctl
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__brk
	.type	__brk, %function
__brk:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_brk
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__getdents
	.type	__getdents, %function
__getdents:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_getdents
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	____getcwd
	.type	____getcwd, %function
____getcwd:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_getcwd
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret
#endif
#endif
